'use strict';

class BaseError extends Error {

    constructor(message, code, previous) {
        super(message);

        this.name = this.constructor.name;

        this.status = code;
        this.code = code;
        this.previous = previous;

        if(typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, this.constructor);

        } else {
            this.stack = (new Error(message)).stack;
        }
    }
}

module.exports = BaseError;